#!/bin/sh
# Filter output of mpi_latency run_tests.sh to find a particular set of
# results.
# Mark Moraes, D. E. Shaw Research & Development, LLC
case $# in
0)	echo "Usage: $0 filename pattern ..." >&2
	echo "	where patterns are float=500 overlap=1 etc" >&2
	echo "Prints results that match all those patterns" >&2
	;;
1)	fname="$1"
	set x "floats=500 overlap=1"
	shift
	;;
*)	fname="$1"
	shift
	;;
esac
egrep '>>>|Avg|Total send' "$fname" |
	gawk -v "pats=$*" 'BEGIN {
		npats = split(pats, vpats)
		debug = 0
		for (i = 1; i <= npats; i++) {
			if (vpats[i] == "debug")
				debug = 1
			else
				hpats[vpats[i]] = i
		}
		if (debug)
			for (i = 1; i <= npats; i++)
				printf "%d: \"%s\"\n", i, vpats[i]
		k = 0
	} 
	$1 == ">>>" {
		k++
		nmatches = 0
		for (i = 2; i <= NF; i++) {
			if ($i in hpats) {
				nmatches++
				if (debug)
					printf "%d: %d: \"%s\" %d\n", k, i, $i, nmatches
			}
		}
		# did all specified patterns match?
		if (nmatches != npats) {
			next
		}
		print; getline;
		print; getline;
		getline; print;
		getline; print
	}'
